package com.gic.cloud.data.hook.service.deal.queryfilter;

import com.gic.api.base.commons.Page;
import com.gic.cloud.data.hook.api.dto.FilterQueryDataDTO;
import com.gic.cloud.data.hook.service.dao.DhFlatQueryFilterItemMapper;
import com.gic.cloud.data.hook.service.dao.DhFlatQueryFilterMapper;
import com.gic.cloud.data.hook.service.deal.BaseQueryFilter;
import com.gic.cloud.data.hook.service.deal.QueryFilterContext;
import com.gic.cloud.data.hook.service.entity.DhFlatQueryFilterItem;
import com.gic.cloud.data.hook.service.entity.QueryFilterInfo;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.PageHelperUtils;
import com.github.pagehelper.PageHelper;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Service
public class EnumQueryFilter implements BaseQueryFilter {

    @Autowired
    private DhFlatQueryFilterItemMapper dhFlatQueryFilterItemMapper;

    @Override
    public boolean checkFilter(QueryFilterContext context) {
        QueryFilterInfo queryFilterInfo = context.getQueryFilterInfo();
        if (queryFilterInfo.getFilterType().intValue() == 0) {
            return true;
        }
        return false;
    }

    @Override
    public Page<FilterQueryDataDTO> pageQueryData(QueryFilterContext context) {
        PageHelper.startPage(context);
        List<DhFlatQueryFilterItem> list = dhFlatQueryFilterItemMapper.listQueryFilterItems(context.getQueryFilterInfo().getFilterId());

        Page<DhFlatQueryFilterItem> retPage = PageHelperUtils.changePageHelperToCurrentPage(list, DhFlatQueryFilterItem.class);
        Page<FilterQueryDataDTO> ret = new Page<>();
        ret.setPageSize(retPage.getPageSize());
        ret.setCurrentPage(retPage.getCurrentPage());
        ret.setTotalCount(retPage.getTotalCount());
        if (CollectionUtils.isEmpty(retPage.getResult())) {
            return ret;
        }
        List<FilterQueryDataDTO> collect = retPage.getResult().stream().map(mid -> {
            FilterQueryDataDTO filterQueryDataDTO = new FilterQueryDataDTO();
            filterQueryDataDTO.setItemValue(mid.getItemValue());
            filterQueryDataDTO.setShowName(mid.getShowName());
            filterQueryDataDTO.setItemId(mid.getItemValue());
            return filterQueryDataDTO;
        }).collect(Collectors.toList());
        ret.setResult(collect);
        return ret;
    }

    @Override
    public List<FilterQueryDataDTO> listBackByItems(QueryFilterContext context) {
        List<String> items = context.getItems();
        List<DhFlatQueryFilterItem> list = dhFlatQueryFilterItemMapper.listQueryFilterItems(context.getQueryFilterInfo().getFilterId());
        List<DhFlatQueryFilterItem> orgItems = list.stream().filter(mid -> items.contains(mid.getItemValue())).collect(Collectors.toList());
        List<FilterQueryDataDTO> collect = orgItems.stream().map(mid -> {
            FilterQueryDataDTO filterQueryDataDTO = new FilterQueryDataDTO();
            filterQueryDataDTO.setItemValue(mid.getItemValue());
            filterQueryDataDTO.setShowName(mid.getShowName());
            filterQueryDataDTO.setItemId(mid.getItemValue());
            return filterQueryDataDTO;
        }).collect(Collectors.toList());
        return collect;
    }
}
